/*
  R.Zinke Aug08
  written for J1J2J3 chain with nn(bond2), nnn(bond1= parameter) 
  and nnnn(bond3) exchange interaction.

  J3=0 --> J1J2 chain model
*/

double usr_angle(int bond, int term13, double *alpha, int numaplha) {

  double mult = 0.0;  // default for term13 = {10,11,12,13}
  double       phi1 =        alpha[0]; 
  double       phi2 =      2*alpha[0];  // nnn-neigbour 
  double       phi3 =      3*alpha[0];  // nnnn-neigbour
  
  if (bond==1) {   // J1 bit now...
    // delta term
    // here it's J_2 coefficients for the 1D spiral J_1--J_2 model
    // now the J_2 part
    if      (term13 == 1) mult=       cos(phi2);    // s^z s^z 
    else if (term13 == 2) mult=  -0.5*sin(phi2);    // s^z s^+ 
    else if (term13 == 3) mult=  -0.5*sin(phi2);    // s^z s^- 
    else if (term13 == 4) mult=   0.5*sin(phi2);    // s^+ s^z
    else if (term13 == 5) mult=   0.5*sin(phi2);    // s^- s^z
    else if (term13 == 6) mult= 0.25*(cos(phi2)+1); // s^+ s^-
    else if (term13 == 7) mult= 0.25*(cos(phi2)+1); // s^- s^+
    else if (term13 == 8) mult= 0.25*(cos(phi2)-1); // s^+ s^+
    else if (term13 == 9) mult= 0.25*(cos(phi2)-1); // s^- s^-
    /* 10..13 ??? */
  } else if (bond==2) {  // J_2 bit now...
    if      (term13 == 1) mult=       -cos(phi1);
    else if (term13 == 2) mult=    0.5*sin(phi1);
    else if (term13 == 3) mult=    0.5*sin(phi1);
    else if (term13 == 4) mult=   -0.5*sin(phi1);
    else if (term13 == 5) mult=   -0.5*sin(phi1);
    else if (term13 == 6) mult= -0.25*(cos(phi1)+1);
    else if (term13 == 7) mult= -0.25*(cos(phi1)+1);
    else if (term13 == 8) mult= -0.25*(cos(phi1)-1);
    else if (term13 == 9) mult= -0.25*(cos(phi1)-1);
  } else {   // J_3 bit now...
    if      (term13 == 1) mult=       -cos(phi3);  
    else if (term13 == 2) mult=    0.5*sin(phi3);
    else if (term13 == 3) mult=    0.5*sin(phi3);
    else if (term13 == 4) mult=   -0.5*sin(phi3);
    else if (term13 == 5) mult=   -0.5*sin(phi3);
    else if (term13 == 6) mult= -0.25*(cos(phi3)+1);
    else if (term13 == 7) mult= -0.25*(cos(phi3)+1);
    else if (term13 == 8) mult= -0.25*(cos(phi3)-1);
    else if (term13 == 9) mult= -0.25*(cos(phi3)-1);
    mult*=-0.09;
  }                                                                     
  return mult;
}
